import gpt_2_simple as gpt2
import os
import arxivscraper as ax
import numpy as np
import tensorflow as tf

model_name = "124M"
if not os.path.isdir(os.path.join("models", model_name)):
    print(f"Downloading {model_name} model...")
    gpt2.download_gpt2(model_name=model_name)
else:
    print("Model exist. Scraping achrives...")

if not os.path.isfile('titles_ref.csv'):
    scraper = ax.Scraper(category='eess', date_from='2024-05-01',
                        date_until='2024-12-03', t=10,
                        filters={'categories':['eess.AS']})

    output = scraper.scrape()

    titles = [' '.join(o['title'].split()) for o in output]
    np.savetxt('titles_ref.csv', np.array(titles), fmt='%s')
else:
    print("Data already scrapped, training model...")

sess = gpt2.start_tf_sess()
gpt2.finetune(sess,
              'titles_ref.csv',
              model_name=model_name,
              steps=500,
              save_every=50,
              sample_every=25)

gpt2.generate(sess)
